# TODO
# - update paths in manuals (create .in files and send upstream)
# - make /etc/pam.d independant of sysconfdir (configure-able option and send upstream)
# - syslog output (-s) writes two bytes of garbage to syslog instead of actual data:
#   Mar  3 09:30:01 ravenous CROND[2528]: 4ÿ
#
# Conditional build:
%bcond_without	inotify		# without inotify support
%if "%{pld_release}" == "ac"
%bcond_with		selinux		# with SELinux support
%bcond_with		audit		# with audit support
%else
%bcond_without	selinux		# without SELinux support
%bcond_without	audit		# without audit support
%endif

Summary:	Cron daemon for executing programs at set times
Summary(pl.UTF-8):	Demon cron do uruchamiania programów o zadanym czasie
Name:		cronie
Version:	1.7.2
Release:	1
License:	MIT and BSD and GPL v2
Group:		Daemons
#Source0Download: https://github.com/cronie-crond/cronie/releases
Source0:	https://github.com/cronie-crond/cronie/releases/download/%{name}-%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	2dacf4a7198b26dbd497a418cf31443d
Source1:	%{name}.init
Source3:	cron.sysconfig
Source4:	%{name}.crontab
Source5:	%{name}.pam
Source6:	crond.service
Patch0:		inotify-nosys.patch
Patch1:		sendmail-path.patch
URL:		https://github.com/cronie-crond/cronie/
%{?with_audit:BuildRequires:	audit-libs-devel}
BuildRequires:	autoconf >= 2.60
BuildRequires:	automake
BuildRequires:	glibc-devel >= 6:2.21
%{?with_selinux:BuildRequires:	libselinux-devel}
BuildRequires:	pam-devel
BuildRequires:	rpm >= 4.4.9-56
BuildRequires:	rpmbuild(macros) >= 1.647
Requires(post):	fileutils
Requires(post,preun):	/sbin/chkconfig
Requires(postun):	/usr/sbin/groupdel
Requires(pre):	/usr/bin/getgid
Requires(pre):	/usr/sbin/groupadd
Requires:	/bin/run-parts
Requires:	psmisc >= 20.1
Requires:	rc-scripts >= 0.4.3.0
%if "%{pld_release}" != "ac"
Requires(post,preun,postun):	systemd-units >= 38
Requires:	systemd-units >= 38}
%endif
%{?with_inotify:Requires:	uname(release) >= 2.6.13}
Provides:	crondaemon
Provides:	crontabs = 1.7
Provides:	cronjobs
Provides:	group(crontab)
%if "%{pld_release}" == "th"
Provides:	vixie-cron = 4.3-1
%endif
Obsoletes:	crondaemon
Obsoletes:	cronie-systemd < 1.4.8-9
Obsoletes:	cronie-upstart < 1.4.12-5
Obsoletes:	crontabs
Obsoletes:	cronjobs
%if "%{pld_release}" == "th"
Obsoletes:	vixie-cron < 4.3-1
%endif
Conflicts:	sysklogd < 1.5.1-2
Conflicts:	syslog-ng < 3.6.4-3
Conflicts:	rsyslog < 5.10.1-4
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Cronie contains the standard UNIX daemon crond that runs specified
programs at scheduled times and related tools. It is based on the
original cron and has security and configuration enhancements like the
ability to use PAM and SELinux.

%description -l pl.UTF-8
Cronie zawiera standardowego demona uniksowego crond, uruchamiającego
podane programy o zadanym czasie, oraz powiązane narzędzia. Jest
oparty na oryginalnym cronie i zawiera rozszerzenia bezpieczeństwa i
konfiguracji, takie jak możliwość wykorzystania mechanizmów PAM i
SELinux.

%package anacron
Summary:	Utility for running regular jobs
Summary(pl.UTF-8):	Narzędzie do uruchamiania regularnych zadań
Group:		Base
Provides:	anacron = 2.4
Obsoletes:	anacron <= 2.3

%description anacron
Anacron becames part of cronie. Anacron is used only for running
regular jobs. The default settings execute regular jobs by anacron,
however this could be overloaded in settings.

%description anacron -l pl.UTF-8
Anacron stał się częścią cronie. Służy tylko do uruchamiania
regularnych zadań. Domyślne ustawienia wykonują zadania przy użyciu
anacrona, ale może to być zmienione w ustawieniach.

%prep
%setup -q
%patch0 -p1
%patch1 -p1

%build
%{__aclocal}
%{__autoconf}
%{__autoheader}
%{__automake}
%configure \
	SYSCRONTAB=/etc/crontab \
	SYS_CROND_DIR=/etc/cron.d \
	--sysconfdir=/etc/cron \
	--with-editor=/bin/vi \
	--with-audit%{!?with_audit:=no} \
	--with-inotify%{!?with_inotify:=no} \
	--with-pam \
	--with-selinux%{!?with_selinux:=no} \
	--disable-silent-rules \
	--disable-syscrontab \
	--enable-anacron \
%if "%{cc_version}" >= "3.4"
	--enable-pie \
%endif
	--enable-relro

%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{/var/{log,spool/{ana,}cron},%{_mandir},%{systemdunitdir}}\
	$RPM_BUILD_ROOT/etc/{rc.d/init.d,logrotate.d,sysconfig} \
	$RPM_BUILD_ROOT%{_sysconfdir}/{cron,cron.{d,hourly,daily,weekly,monthly},pam.d}

%{__make} install \
	pamdir=/etc/pam.d \
	DESTDIR=$RPM_BUILD_ROOT

cp -p %{SOURCE5} crond.pam

%if %{without audit}
# remove recording user's login uid to the process attribute
%{__sed} -i -e '/pam_loginuid.so/d' crond.pam
%endif

install -p %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/crond
cp -a contrib/0anacron $RPM_BUILD_ROOT/etc/cron.hourly/0anacron
cp -a contrib/anacrontab $RPM_BUILD_ROOT/etc/cron/anacrontab
cp -a %{SOURCE3} $RPM_BUILD_ROOT/etc/sysconfig/cron
cp -a %{SOURCE4} $RPM_BUILD_ROOT/etc/cron.d/crontab
cp -a crond.pam  $RPM_BUILD_ROOT/etc/pam.d/crond
cp -a %{SOURCE6} $RPM_BUILD_ROOT%{systemdunitdir}/crond.service

cat > $RPM_BUILD_ROOT%{_sysconfdir}/cron/cron.allow << 'EOF'
# cron.allow	This file describes the names of the users which are
#		allowed to use the local cron daemon
root
EOF

cat > $RPM_BUILD_ROOT%{_sysconfdir}/cron/cron.deny << 'EOF'
# cron.deny	This file describes the names of the users which are
#		NOT allowed to use the local cron daemon
EOF

cat > $RPM_BUILD_ROOT%{_sysconfdir}/cron.daily/check-crond << 'EOF'
#!/bin/sh

# ugly and limited hack. make cronie restart itself
if [ -x /bin/awk -a -x /bin/grep -a -f /var/log/cron ]; then
	LC_ALL=C /bin/awk -v d="$(LC_ALL=C date "+%b %e")" ' $1 " " $2 ~ d' /var/log/cron \
		| /bin/grep -qE "PAM.*(Modu. jest nieznany|Module is unknown)" \
		&& echo "crond is failing on PAM, restarting ( https://github.com/cronie-crond/cronie/issues/87 )" >&2 \
		&& /sbin/service crond try-restart
fi
exit 0
EOF

%clean
rm -rf $RPM_BUILD_ROOT

%pre
%groupadd -g 117 -r -f crontab

%post
/sbin/chkconfig --add crond
%service crond restart "Cron Daemon"
%systemd_post crond.service

%preun
if [ "$1" = "0" ]; then
	%service crond stop
	/sbin/chkconfig --del crond
fi
%systemd_preun crond.service

%postun
if [ "$1" = "0" ]; then
	%groupremove crontab
fi
%systemd_reload

%triggerpostun -- cronie < 1.4.8-13
if [ -f /etc/sysconfig/cron ]; then
	. /etc/sysconfig/cron
	__CROND_ARGS=
	[ "$CROND_SYSLOG_RESULT" = "yes" ] && __CROND_ARGS="-s"
	[ -n "$CROND_MAIL_PROG" ] && __CROND_ARGS="$__CROND_ARGS -m $CROND_MAIL_PROG"
	if [ -n "$__CROND_ARGS" ]; then
		%{__cp} -f /etc/sysconfig/cron{,.rpmsave}
		echo >>/etc/sysconfig/cron
		echo "# Added by rpm trigger" >>/etc/sysconfig/cron
		echo "CROND_ARGS=\"$CROND_ARGS $__CROND_ARGS\"" >>/etc/sysconfig/cron
	fi
fi
%systemd_trigger crond.service

%triggerun -- hc-cron,fcron,vixie-cron < 4.3-1
# Prevent preun from crond from working
chmod a-x /etc/rc.d/init.d/crond

%triggerpostun -- hc-cron,fcron,vixie-cron < 4.3-1
# Restore what triggerun removed
chmod 754 /etc/rc.d/init.d/crond
# reinstall crond init.d links, which could be different
/sbin/chkconfig --del crond
/sbin/chkconfig --add crond

%files
%defattr(644,root,root,755)
%doc AUTHORS ChangeLog README
%attr(750,root,crontab) %dir /etc/cron
%attr(750,root,crontab) %dir /etc/cron.daily
%attr(750,root,root) /etc/cron.daily/check-crond
%attr(750,root,crontab) %dir /etc/cron.hourly
%attr(750,root,crontab) %dir /etc/cron.monthly
%attr(750,root,crontab) %dir /etc/cron.weekly
%attr(640,root,crontab) %config(noreplace,missingok) /etc/cron.d/crontab
%attr(640,root,crontab) %config(noreplace,missingok) %verify(not md5 mtime size) %{_sysconfdir}/cron/cron.allow
%attr(640,root,crontab) %config(noreplace,missingok) %verify(not md5 mtime size) %{_sysconfdir}/cron/cron.deny
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/cron
%config(noreplace) %verify(not md5 mtime size) /etc/pam.d/crond
%attr(754,root,root) /etc/rc.d/init.d/crond
%{systemdunitdir}/crond.service
%attr(755,root,root) %{_sbindir}/crond
%attr(2755,root,crontab) %{_bindir}/cronnext
%attr(2755,root,crontab) %{_bindir}/crontab

%{_mandir}/man8/crond.8*
%{_mandir}/man8/cron.8*
%{_mandir}/man5/crontab.5*
%{_mandir}/man1/cronnext.1*
%{_mandir}/man1/crontab.1*

%attr(1730,root,crontab) /var/spool/cron

%files anacron
%defattr(644,root,root,755)
%attr(755,root,root) %{_sbindir}/anacron
%attr(755,root,root) %{_sysconfdir}/cron.hourly/0anacron
%attr(640,root,crontab) %config(noreplace,missingok) %verify(not md5 mtime size) /etc/cron/anacrontab
%{_mandir}/man5/anacrontab.5*
%{_mandir}/man8/anacron.8*

%attr(1730,root,crontab) /var/spool/anacron
%changelog
* Thu Apr 11 2024 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/cronie.git;a=log;h=master

* Tue Apr 09 2024 Jakub Bogusz <qboosh@pld-linux.org> c6a9f00
- updated to 1.7.2

* Fri Jan 12 2024 Jan Palus <atler@pld-linux.org> 8ae0d86
- up to 1.7.1

* Wed Nov 08 2023 Jakub Bogusz <qboosh@pld-linux.org> dc1bdb1
- versioned Obsoletes for removed packages

* Fri Oct 13 2023 Jan Palus <atler@pld-linux.org> 2a78eec
- up to 1.7.0

* Tue Aug 23 2022 Arkadiusz Miśkiewicz <arekm@maven.pl> 1529bcc
- Up to 1.6.1. Fix restart on pam failure.

* Wed Feb 09 2022 Arkadiusz Miśkiewicz <arekm@maven.pl> 46cacb4
- Rel 7; report script filename if it produces any output.

* Thu Dec 16 2021 Arkadiusz Miśkiewicz <arekm@maven.pl> 216820e
- Rel 6; condrestart instead of restart and always exit with 0 status

* Tue Nov 23 2021 Arkadiusz Miśkiewicz <arekm@maven.pl> 428b9c7
- Rel 4; make cronie restart itself when PAM problems happen.

* Sat Nov 20 2021 Jan Rękorajski <baggins@pld-linux.org> 7e9736c
- rebuild with separate debuginfo build-ids

* Fri Apr 09 2021 Jan Palus <atler@pld-linux.org> b3ee8d6
- up to 1.5.7

* Sat Mar 20 2021 Arkadiusz Miśkiewicz <arekm@maven.pl> 356b432
- Rediff patch.

* Thu Feb 06 2020 Arkadiusz Miśkiewicz <arekm@maven.pl> d0704c8
- up to 1.5.5

* Tue Mar 19 2019 Arkadiusz Miśkiewicz <arekm@maven.pl> d73b566
- up to 1.5.4; fixes regression in 1.5.3

* Sun Mar 17 2019 Arkadiusz Miśkiewicz <arekm@maven.pl> aab1a55
- up to 1.5.3; fixes CVE-2019-9704 and CVE-2019-9705

* Wed Oct 10 2018 Elan Ruusamäe <glen@delfi.ee> 6415010
- make pam_loginuid optional

* Thu Jul 26 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 1c89d0c
- up to 1.5.2

* Thu Dec 21 2017 Arkadiusz Miśkiewicz <arekm@maven.pl> 51c33ef
- update url

* Fri Mar 10 2017 Jacek Konieczny <j.konieczny@eggsoft.pl> c42787e
- No one seems to mind, Release: 2

* Thu Mar 09 2017 Jacek Konieczny <j.konieczny@eggsoft.pl> af95f65
- P: cronjobs, O: cronjobs

* Tue Feb 07 2017 Jakub Bogusz <qboosh@pld-linux.org> b81cc12
- pl

